%This M-Function was created automatically by PSG Toolbox.
%See section "Special Subroutines in Toolbox -> User Subroutine in Toolbox" in PSG Help Manual.
%
%Input variables:
%
%Inputs                 PSG Type    PSG Object      Location in Problem Statement                               Class
%matrix_mn              data        matrix_mn       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%                                   matrix_mn_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%header_matrix_mn_vr    vars        matrix_mn       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    cell
%                                   matrix_vr       wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                   matrix_mn_1     ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)
%                                   matrix_vr_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%matrix_vr              data        matrix_vr       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%                                   matrix_vr_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%vector_yi_data         data        vector_yi       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%vector_qi_data         data        vector_qi       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%matrix_ss_data         data        matrix_ss       linear(matrix_ss)                                           double
%matrix_ss_vars         vars        matrix_ss       linear(matrix_ss)                                           cell
%matrix_ss_bench        bench       matrix_ss       linear(matrix_ss)                                           double
%vector_param_data      data        vector_param    wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)            double
%vector_lb_data         data        vector_lb       MultiConstraint: >= vector_lb                               double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


function [solution_str,outargstruc_arr] = Optimization_subroutine(matrix_mn,header_matrix_mn_vr,matrix_vr,vector_yi_data,vector_qi_data,matrix_ss_data,matrix_ss_vars,matrix_ss_bench,vector_param_data,vector_lb_data)

%Pack data to PSG structure:
count = 0;
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_mn',matrix_mn,header_matrix_mn_vr,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_vr',matrix_vr,header_matrix_mn_vr,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_yi',vector_yi_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_qi',vector_qi_data);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_ss',matrix_ss_data,matrix_ss_vars,matrix_ss_bench,[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_mn_1',matrix_mn,header_matrix_mn_vr,[],[]);
count = count+1;
iargstruc_arr(count) = matrix_pack('matrix_vr_1',matrix_vr,header_matrix_mn_vr,[],[]);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_param',vector_param_data);
count = count+1;
iargstruc_arr(count) = vector_pack('vector_lb',vector_lb_data);
%Define problem statement:
problem_statement = sprintf('%s\n',...
'minimize',...
'	ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)',...
'Constraint: = 1',...
'	linear(matrix_ss)',...
'MultiConstraint: >= vector_lb',...
'	wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)',...
'Box: >= 0, <=1',...
' ',...
' ');
%Change parameters with their values in problem statement:

%Optimize problem using mpsg_solver function:
[solution_str, outargstruc_arr] = mpsg_solver(problem_statement, iargstruc_arr);
results = psg_convert_outargstruc(solution_str,outargstruc_arr);
outargstruc_arr = results.data;
solution_str = results.string;

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 

