%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%minimize
%ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)
%Constraint: = 1
%linear(matrix_ss)
%MultiConstraint: >= vector_lb
%wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%Box: >= 0, <=1
%
%
%Input variables:
%
%Inputs                 PSG Type    PSG Object      Location in Problem Statement                               Class
%matrix_mn              data        matrix_mn       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%                                   matrix_mn_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%header_matrix_mn_vr    vars        matrix_mn       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    cell
%                                   matrix_vr       wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                   matrix_mn_1     ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)
%                                   matrix_vr_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%matrix_vr              data        matrix_vr       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%                                   matrix_vr_1     wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%                                                   wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)
%vector_yi_data         data        vector_yi       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%vector_qi_data         data        vector_qi       ksm_cvar_ni(0.0,matrix_mn,matrix_vr,vector_yi,vector_qi)    double
%matrix_ss_data         data        matrix_ss       linear(matrix_ss)                                           double
%matrix_ss_vars         vars        matrix_ss       linear(matrix_ss)                                           cell
%matrix_ss_bench        bench       matrix_ss       linear(matrix_ss)                                           double
%vector_param_data      data        vector_param    wcvar_ni(vector_param, matrix_mn_1, matrix_vr_1)            double
%vector_lb_data         data        vector_lb       MultiConstraint: >= vector_lb                               double
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB\CS_Fitting_mixture_models_with_CVaR_constraints\case study\Matlab code\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_mn,header_matrix_mn_vr,matrix_vr,vector_yi_data,vector_qi_data,matrix_ss_data,matrix_ss_vars,matrix_ss_bench,vector_param_data,vector_lb_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2017.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
